CKSUM(1) | General Commands Manual | CKSUM(1)

# NAME

`cksum`, `md2`, `md4`, `md5`, `rmd160`, `sha1`, `sha256`, `sha384`, `sha512`, `sum` — display file checksums and block counts

# SYNOPSIS

`cksum` | [`-n`] [`-a` algorithm [`-pqtx`] [`-s` string]] [`-o` 1|2] [file ... `|` `-c` [`-w`] [sumfile]]

`sum` | [`-n`] [`-a` algorithm [`-pqtx`] [`-s` string]] [`-o` 1|2] [file ... `|` `-c` [`-w`] [sumfile]]

`md2` | [`-npqtx`] [`-s` string] [file ... `|` `-c` [`-w`] [sumfile]]

`md4` | [`-npqtx`] [`-s` string] [file ... `|` `-c` [`-w`] [sumfile]]

`md5` | [`-npqtx`] [`-s` string] [file ... `|` `-c` [`-w`] [sumfile]]

`rmd160` | [`-npqtx`] [`-s` string] [file ... `|` `-c` [`-w`] [sumfile]]

`sha1` | [`-npqtx`] [`-s` string] [file ... `|` `-c` [`-w`] [sumfile]]

`sha256` | [`-npqtx`] [`-s` string] [file ... `|` `-c` [`-w`] [sumfile]]

`sha384` | [`-npqtx`] [`-s` string] [file ... `|` `-c` [`-w`] [sumfile]]

`sha512` | [`-npqtx`] [`-s` string] [file ... `|` `-c` [`-w`] [sumfile]]

# DESCRIPTION

The `cksum` utility writes to the standard output three whitespace separated fields for each input file. These fields are a checksum CRC, the total number of octets in the file and the file name. If no file name is specified, the standard input is used and no file name is written.

The `sum` utility is identical to the `cksum` utility, except that it defaults to using historic algorithm 1, as described below. It is provided for compatibility only.

The `md2`, `md4`, `md5`, `sha1`, `sha256`, `sha384`, `sha512`, and `rmd160` utilities compute cryptographic hash functions, and write to standard output the hexadecimal representation of the hash of their input.

The options are as follows:

`-a` algorithm
  When invoked as `cksum`, use the specified algorithm. Valid algorithms are:

  Algorithm | Bits | Description
  `CRC` | 32 | Default CRC algorithm
  `MD2` | 128 | MD2, per `RFC1319`
  `MD4` | 128 | MD4, per `RFC1320`
  `MD5` | 128 | MD5, per `RFC1321`
  `RMD160` | 160 | RIPEMD-160
  `SHA1` | 160 | SHA-1, per `FIPS PUB 180-1`
  `SHA256` | 256 | SHA-2
  `SHA384` | 384 | SHA-2
  `SHA512` | 512 | SHA-2
  `old1` | 16 | Algorithm 1, per `-o` 1
  `old2` | 16 | Algorithm 2, per `-o` 2

`-c` [sumfile]
  Verify (check) files against a list of checksums. The list is read from sumfile, or from stdin if no filename is given. E.g. first run
  ``md5 *.tgz > MD5``
  ``sha1 *.tgz > SHA1``
  to generate a list of MD5 checksums in MD5, then use the following command to verify them:
  ``cat MD5 SHA1` | `cksum -c``
  If an error is found during checksum verification, an error message is printed, and the program returns an error code of 1.
`-o`
  Use historic algorithms instead of the (superior) default one.

  Algorithm 1 is the algorithm used by historic BSD systems as the sum(1) algorithm and by historic AT&T System V UNIX systems as the sum(1) algorithm when using the `-r` option. This is a 16-bit checksum, with a right rotation before each addition; overflow is discarded.

  Algorithm 2 is the algorithm used by historic AT&T System V UNIX systems as the default sum(1) algorithm. This is a 32-bit checksum, and is defined as follows:

      s = sum of all bytes;
      r = s % 2^16 + (s % 2^32) / 2^16;
      cksum = (r % 2^16) + r / 2^16;

  Both algorithm 1 and 2 write to the standard output the same fields as the default algorithm except that the size of the file in bytes is replaced with the size of the file in blocks. For historic reasons, the block size is 1024 for algorithm 1 and 512 for algorithm 2. Partial blocks are rounded up.

`-w`
  Print warnings about malformed checksum files when verifying checksums with `-c`.

The following options apply only when using the one of the message digest algorithms:

`-n`
  Print the hash and the filename in the normal sum output form, with the hash at the left and the filename following on the right.
`-p`
  Echo input from standard input to standard output, and append the selected message digest.
`-q`
  Quiet mode — only the checksum is printed out. Overrides the `-n` option.
`-s` string
  Print the hash of the given string string.
`-t`
  Run a built-in message digest time trial.
`-x`
  Run a built-in message digest test script. The tests that are run are supposed to encompass all the various tests in the suites that accompany the algorithms' descriptions with the exception of the last test for the SHA-1 algorithm and the RIPEMD-160 algorithm. The last test for these is one million copies of the lower letter a.

The default CRC used is based on the polynomial used for CRC error checking in the networking standard ISO 8802-3: 1989. The CRC checksum encoding is defined by the generating polynomial:

    G(x) = x^32 + x^26 + x^23 + x^22 + x^16 + x^12 +
         x^11 + x^10 + x^8 + x^7 + x^5 + x^4 + x^2 + x + 1

Mathematically, the CRC value corresponding to a given file is defined by the following procedure:

The n bits to be evaluated are considered to be the coefficients of a mod 2 polynomial M(x) of degree n-1. These n bits are the bits from the file, with the most significant bit being the most significant bit of the first octet of the file and the last bit being the least significant bit of the last octet, padded with zero bits (if necessary) to achieve an integral number of octets, followed by one or more octets representing the length of the file as a binary value, least significant octet first. The smallest number of octets capable of representing this integer are used.

M(x) is multiplied by x^32 (i.e., shifted left 32 bits) and divided by G(x) using mod 2 division, producing a remainder R(x) of degree ≤ 31.

The coefficients of R(x) are considered to be a 32-bit sequence.

The bit sequence is complemented and the result is the CRC.

The `cksum` and `sum` utilities exit 0 on success, and >0 if an error occurs.

# SEE ALSO

openssl(1), mtree(8)

The default calculation is identical to that given in pseudo-code in the following ACM article.

Dilip V. Sarwate, Computation of Cyclic Redundancy Checks Via Table Lookup, Communications of the ACM, August 1988.

R. Rivest, The MD2 Message-Digest Algorithm, RFC 1319.

R. Rivest, The MD4 Message-Digest Algorithm, RFC 1186 and RFC 1320.

R. Rivest, The MD5 Message-Digest Algorithm, RFC 1321.

U.S. DOC/NIST, Secure Hash Standard, FIPS PUB 180-1.

# STANDARDS

The `cksum` utility is expected to conform to IEEE Std 1003.1-2004 (“POSIX.1”).

# HISTORY

The `cksum` utility appeared in 4.4BSD. `md5` was added in NetBSD 1.3. The functionality for `md2`, `md4`, `sha1`, and `rmd160` was added in NetBSD 1.6. Support for the SHA-2 algorithms (`SHA256`, `SHA384`, and `SHA512`) was added in NetBSD 3.0. The functionality to verify checksum stored in a file (`-c`) first appeared in NetBSD 4.0. Quiet mode (`-q`) was added in NetBSD 7.0.

December 14, 2019 | NetBSD 10.99